unit functions;

interface

function Fibonacci(n: Integer): Integer;
function Fibonacci_Rekursiv_Help(n,f1,f2: Integer): Integer;
function fiboRE(a:integer):integer;

function fak_help(x,y:integer):integer;
function fak2(n:integer):integer;
function fak1(n:integer):integer;

function potenz_end(b,e:integer):integer;
function potenz_help(b,e,zw:integer):integer;
function potenz(b,e:integer):integer;

implementation

// Fibonacci - endrekursiv
function Fibonacci(n: Integer): Integer;
    begin
      if n<3 then Result:=1
      else
        Result:=Fibonacci_Rekursiv_Help(n,1,1);
    end;


function Fibonacci_Rekursiv_Help(n,f1,f2: Integer): Integer;
    begin
      if n<3 then Result:=f2
      else
        Result:=Fibonacci_Rekursiv_Help(n-1, f2,f1+f2);
    end;

// Fibonacci - direkt rekursiv
function fiboRE(a:integer):integer;
begin
  if a <= 2 then result := 1
  else result := fiboRE(a-1) + fiboRE(a-2)
end;

//Fakultt - endrekursiv

function fak_help(x,y:integer):integer;
begin
if y=0 then result:=x
else
result:=fak_help(x*y,y-1);
end;


function fak2(n:integer):integer;
begin
if n=0 then result:=1
else
result:=fak_help(1,n);
end;



// Fakultt - direkt rekursiv

function fak1(n:integer):integer;
begin
if n=0 then result:=1
else
result:=n*fak1(n-1);
end;

//Potenz endrekursiv

function potenz_end(b,e:integer):integer;
begin
 if e=0 then result :=1
 else
 result:=potenz_help(b,e,1);
end;

function potenz_help(b,e,zw:integer):integer;
begin
if e=0 then result:=1
else
result:=potenz_help(b,e,zw*b);
end;

// Potenz direkt rekursiv
function potenz(b,e:integer):integer;
begin
if e=0 then result:=1
else
result:=b*potenz(b,e-1);
end;



end.
 